unit HlavniOkno;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons;

type
  TForm1 = class(TForm)
    otevrit: TOpenDialog;
    itrasa: TImage;
    Panel1: TPanel;
    bnacist: TButton;
    stmapa: TStaticText;
    Panel2: TPanel;
    btrasa: TButton;
    zmenit: TSaveDialog;
    najdicestu: TBitBtn;
    trasafile: TStaticText;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    StaticText3: TStaticText;
    StaticText4: TStaticText;
    StaticText5: TStaticText;
    StaticText6: TStaticText;
    legend: TShape;
    procedure bnacistClick(Sender: TObject);
    procedure zobrazmapu(obraz:string);
    procedure btrasaClick(Sender: TObject);
    procedure najdicestuClick(Sender: TObject);
    procedure StaticText5MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure StaticText6MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure StaticText4MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure StaticText2MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure StaticText3MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure itrasaMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  fmapa,ftrasa:string;
  F:textfile;
  Xlength,Ylength:integer; //Velikosti obrazu
  mapa:array of array of char;


implementation

{$R *.dfm}

procedure tform1.zobrazmapu(obraz:string); //Zobraz mapu
var
 X,Y:integer; //dc promnn cyklu
 Xzvets,Yzvets:integer;
 Znak:char;Radek:string;
begin
 try
  assignfile(F,obraz);
  reset(F);
 except begin
         showmessage('Vyskytla se chyba pi ten souboru!');
         exit;
        end;
 end;

 xlength:=0;
 ylength:=0;

 repeat            // "Zmen" mapy
 inc(Ylength);
 readln(f,radek);
 until eof(f);

 reset(f);

 repeat
 Xlength:=xlength+1;
 read(f,znak);
 until eoln(f);



 If (Xlength>255) or (Ylength>255) then
  begin
   showmessage('Chybn rozmry (Vt ne 255x255)!');
   exit;
  end;

 Xzvets:=trunc(255/xlength);
 Yzvets:=trunc(255/Ylength);
 Reset(F);

 for Y:=1 to Ylength do
  begin
   readln(f,radek);
   for X:=1 to Xlength do
    begin
     znak:=radek[X];
     case Znak of
      'X':itrasa.Canvas.brush.Color:=clblack;
      'S':itrasa.Canvas.brush.Color:=clblue;
      'C':itrasa.Canvas.brush.Color:=clred;
      '.':itrasa.Canvas.brush.Color:=clgreen;
      ':':itrasa.Canvas.brush.Color:=cllime;
     end; {Case}
     itrasa.Canvas.fillrect(rect((X-1)*Xzvets,(Y-1)*Yzvets,(X)*Xzvets,(Y)*Yzvets));
    end;
   end;
   itrasa.Width:=xlength*xzvets;
   itrasa.Height:=ylength*yzvets;

   {reset(f);        Ternto kus programovho kdu mi z neznmho dvodu nefunguje
   x:=0;
   y:=1;
   repeat
   inc(x);
   mapa[x,y]:=radek[x];
   if x=xlength then begin
                      x:=0;
                      inc(y);
                      if y>ylength then break;
                      readln(f,radek);
                     end;
   until false;    }
   end;


procedure TForm1.bnacistClick(Sender: TObject);
begin
 najdicestu.Enabled:=false;
 if otevrit.Execute then
 begin
  najdicestu.Enabled:=true;
  fmapa:=otevrit.FileName;
  ftrasa:=otevrit.Filename;
  delete(ftrasa,length(ftrasa)-3,4);
  ftrasa:=ftrasa+'_trasa';
  ftrasa:=ftrasa+'.txt';
  trasafile.Caption:=ftrasa;
  stmapa.Caption:=otevrit.FileName;
  zobrazmapu(stmapa.Caption);
 end;
end;

procedure TForm1.btrasaClick(Sender: TObject);
begin
if zmenit.Execute then begin
                        ftrasa:=zmenit.FileName;
                        trasafile.Caption:=zmenit.filename;
                       end;
end;


procedure pohyb(actx,acty,speedx,speedy:integer);
begin
 if mapa[actx,acty]='X' then exit
                        else begin
                              pohyb(actx+speedx+1,acty+speedy,speedx+1,speedy);
                              pohyb(actx+speedx+1,acty+speedy+1,speedx+1,speedy+1);
                              pohyb(actx+speedx,acty+speedy+1,speedx,speedy+1);
                              pohyb(actx+speedx-1,acty+speedy+1,speedx-1,speedy+1);
                              pohyb(actx+speedx-1,acty+speedy,speedx-1,speedy);
                              pohyb(actx+speedx-1,acty+speedy-1,speedx-1,speedy-1);
                              pohyb(actx+speedx,acty+speedy-1,speedx,speedy-1);
                              pohyb(actx+speedx+1,acty+speedy-1,speedx+1,speedy-1);
                             end;
 end;
procedure TForm1.najdicestuClick(Sender: TObject);
var
 cesty:array of integer;
 ncest,x,y:integer;
 ende:boolean;
begin
 for x:=1 to xlength do begin
 if ende then break;
 for y:=1 to ylength do
 if mapa[x,y]='S' then begin
                        pohyb(x,y,0,0);
                        ende:=true;
                        break;
                       end;
 end;
end;

procedure TForm1.StaticText5MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
 legend.Brush.Color:=clblue;
end;

procedure TForm1.StaticText6MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
 legend.Brush.Color:=clred;
end;

procedure TForm1.StaticText4MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
 legend.Brush.Color:=cllime;
end;

procedure TForm1.StaticText2MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
 legend.Brush.Color:=clblack;
end;

procedure TForm1.StaticText3MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
 legend.Brush.Color:=clgreen;
end;

procedure TForm1.itrasaMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
statictext1.Font.style:=[];
statictext2.Font.style:=[];
statictext3.Font.style:=[];
statictext4.Font.style:=[];
statictext5.Font.style:=[];
statictext6.Font.style:=[];

 case itrasa.Canvas.Pixels[x,y] of
  clblack:statictext2.Font.style:=[fsbold];
  clgreen:statictext3.Font.style:=[fsbold];
  cllime:statictext4.Font.style:=[fsbold];
  clred:statictext6.Font.style:=[fsbold];
  clblue:statictext5.Font.style:=[fsbold];
 end;
end;

end.
